

///////////////////////////////
//Struktury urcene na citanie//
///////////////////////////////

//
//FACE truktura 
//
struct RBSPFACE
{
	int Index;  //index

	VECTOR3D P[3]; //vertexi
	VECTOR2D T1[3]; //texturove kordinaty
	VECTOR2D T2[3]; //lightmap kordinaty
	int Group;  //index skupiny
	int Plane;  //index roviny
};

//
//GROUP truktura 
//
struct RBSPGROUP
{
	int Index; 

	char Texture[80];
	int BlendType;
	int Type;
	int CollisionType;
	int LightMapIndex;
};

//
//RBSPPLANE truktura
//
struct RBSPPLANE
{
	int Index;

	VECTOR3D Normal;
	float D;
};


//
//LIGHT truktura
//
struct RBSPLIGHT
{
	int Index;
	
	VECTOR3D Pos;
	COLOR Color;
	float Intensity;
	float Range;
	bool Corona;
};

//
//NODE
//
struct RBSPNODE
{
	int Index;
	
	  int BackIndex;
	  int FrontIndex;

	VECTOR3D Min;
	VECTOR3D Max;
	float Radius;
	VECTOR3D Centre;

	bool Solid;

	bool Leaf;
	  int LeafIndex;

	int Root;
};

//
//BSPLEAF
//
struct RBSPLEAF
{
	int Index;

	int *FaceList;
	int NumFaces;

	VECTOR3D Min;
	VECTOR3D Max;
	float Radius;
	VECTOR3D Centre;

	int *VisibleLeafs;
	int NumVisibleLeafs;
};

//
//LIGHTMAPA
//
struct RBSPLIGHTMAP
{
	int Index;
	
	byte Texel[256][256][3];
};